// (c) dUkk
#include "stdafx.h"
#include "ntserv_msg.h"
#include "ntservEventLog.h"
#include "app.h"
#include <Lm.h>
#include <Aclapi.h>

//const GUID GUID_DEVINTERFACE_USB_DEVICE = { 0xA5DCBF10L, 0x6530, 0x11D2, { 0x90, 0x1F, 0x00, 0xC0, 0x4F, 0xB9, 0x51, 0xED } };
const GUID GUID_DEVINTERFACE_VOLUME = { 0x53f5630dL, 0xb6bf, 0x11d0, { 0x94, 0xf2, 0x00, 0xa0, 0xc9, 0x1e, 0xfb, 0x8b } }; 

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//The one and only one application
CWinApp theApp;

#ifdef _DEBUG
BOOL CALLBACK EnumServices(void* /*pData*/, ENUM_SERVICE_STATUS& Service)
#else
BOOL CALLBACK EnumServices(void* /*pData*/, ENUM_SERVICE_STATUS& /*Service*/)
#endif
{
#ifdef _DEBUG
	TRACE(_T("Service name is %s\n"), Service.lpServiceName);
	TRACE(_T("Friendly name is %s\n"), Service.lpDisplayName);
#endif

	return TRUE; //continue enumeration
}


int _tmain(int /*argc*/, TCHAR* /*argv*/[], TCHAR* /*envp*/[])
{
	//Don't forget to explicitly initialize MFC, since we are in a console app (Note we must put up with some /analyze warnings for AfxWinInit even in VC 2008)
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
		return 1;

	//All that is required to get the service up and running
	CNTServiceCommandLineInfo cmdInfo;
	CMyService Service;
	Service.SetAllowCommandLine(TRUE);
	Service.ParseCommandLine(cmdInfo);
	return Service.ProcessShellCommand(cmdInfo);
}



CMyService::CMyService() : CNTService(_T("AutoShServ"), _T("Autoshare service"), SERVICE_ACCEPT_STOP, _T("Autoshare service")),
	                       m_lWantStop(FALSE)    //Simple boolean which is set to request the service to stop
{
	wlist_len=0;

	for(int a=0;a<5;a++)
	{
		watchlist[a].hDir=INVALID_HANDLE_VALUE;
		memset(&watchlist[a].myov_struct,0, sizeof(OVERLAPPED));
	}
}

void CMyService::ServiceMain(DWORD /*dwArgc*/, LPTSTR* /*lpszArgv*/)
{
	CString msg;
	int a;
	//BYTE buf1[8192], buf2[8192], buf3[8192];
	//DWORD buff_len1=0, buff_len2=0, buff_len3=0;
	//DWORD outSize1 = sizeof(buf1), outSize2 = sizeof(buf2), outSize3 = sizeof(buf3);
	//OVERLAPPED myov_struct1 = {0}, myov_struct2 = {0}, myov_struct3 = {0};
	//HANDLE hDir1 = INVALID_HANDLE_VALUE, hDir2 = INVALID_HANDLE_VALUE, hDir3 = INVALID_HANDLE_VALUE;

	ReportStatus(SERVICE_START_PENDING, 1, 100);

	if(!LoadConfiguration()) return;

	//initialize kernel events
	for(a=0;a<3+wlist_len;a++) hOurHandlesArr[a] = CreateEvent(NULL, TRUE, FALSE, NULL);

	//open initial handles to watched dirs
	for(a=0;a<wlist_len;a++)
	{
		CString t;

		watchlist[a].myov_struct.hEvent = hOurHandlesArr[3+a];
		watchlist[a].hDir=CreateFile(watchlist[a].fullpath, FILE_LIST_DIRECTORY, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS | FILE_FLAG_OVERLAPPED, NULL);
		if(watchlist[a].hDir == INVALID_HANDLE_VALUE) 
		{
			t.Format(_T("Error can't open handle to %s , will not watching here"), watchlist[a].fullpath);
			m_EventLogSource.Report(EVENTLOG_ERROR_TYPE, t);
		}
		else
		{
			DWORD buff_len=0;
			DWORD outsize2=sizeof(watchlist[a].asyncbuf);
			if(ReadDirectoryChangesW(watchlist[a].hDir, &watchlist[a].asyncbuf, outsize2, FALSE, FILE_NOTIFY_CHANGE_DIR_NAME, &buff_len, &watchlist[a].myov_struct, NULL) != 0)
			{
				t.Format(_T("Succeed set asynchronous ReadDirectoryChangesW(%s)"), watchlist[a].fullpath);
				m_EventLogSource.Report(EVENTLOG_INFORMATION_TYPE, t);
			}	
			else 
			{
				LPVOID lpMsgBuf;
				FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, NULL, GetLastError(), 0, (LPTSTR) &lpMsgBuf, 0, NULL);
				t.Format(_T("Failed set asynchronous ReadDirectoryChangesW(%s): %s, will try again later..."), watchlist[a].fullpath, lpMsgBuf);
				LocalFree(lpMsgBuf);
				m_EventLogSource.Report(EVENTLOG_ERROR_TYPE, t);
			}
		}
	}
	
	//signal OS that we want notification for drives arrival/disappear
	DEV_BROADCAST_DEVICEINTERFACE NotificationFilter = {0};
	NotificationFilter.dbcc_size = sizeof(DEV_BROADCAST_DEVICEINTERFACE); 
	NotificationFilter.dbcc_devicetype = DBT_DEVTYP_DEVICEINTERFACE; 
	NotificationFilter.dbcc_classguid =  GUID_DEVINTERFACE_VOLUME; //GUID of interface that we decide to receive events...
	hDevNotify = RegisterDeviceNotification(m_hStatus, &NotificationFilter, DEVICE_NOTIFY_SERVICE_HANDLE);
	//
	if(hDevNotify == NULL) 
	{
		m_EventLogSource.Report(EVENTLOG_ERROR_TYPE, _T("Error: Cannot setup device notification to receive volumes mount/unmount notifications!"));
		for(a=0;a<wlist_len;a++)
		{
			CancelIo(watchlist[a].hDir);
			CloseHandle(watchlist[a].hDir);
		}
		for(a=0;a<3+wlist_len;a++) if (hOurHandlesArr[a]) CloseHandle(hOurHandlesArr[a]);
		return;
	}

	ReportStatus(SERVICE_RUNNING);

	while (!m_lWantStop)
	{
		DWORD dwRet=WaitForMultipleObjects(3+wlist_len, hOurHandlesArr, FALSE, INFINITE);
		//someone signalled us to finish
		if(dwRet == WAIT_OBJECT_0) 
			break;
		//device arrival/dissapear
		else if(dwRet == WAIT_OBJECT_0+1)
		{
			for(a=0;a<wlist_len;a++)
			{
				CString t;
				if(watchlist[a].hDir != INVALID_HANDLE_VALUE) 
				{
					CancelIo(watchlist[a].hDir);
					CloseHandle(watchlist[a].hDir);
				}
				watchlist[a].hDir=CreateFile(watchlist[a].fullpath, FILE_LIST_DIRECTORY, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS | FILE_FLAG_OVERLAPPED, NULL);
				if(watchlist[a].hDir == INVALID_HANDLE_VALUE) 
				{
					t.Format(_T("Volume contains %s probably dismounted, shutdown watching..."), watchlist[a].fullpath);
					m_EventLogSource.Report(EVENTLOG_INFORMATION_TYPE, t);
				}
				else
				{
					DWORD buff_len=0;
					if(ReadDirectoryChangesW(watchlist[a].hDir, &watchlist[a].asyncbuf, sizeof(watchlist[a].asyncbuf), FALSE, FILE_NOTIFY_CHANGE_DIR_NAME, &buff_len, &watchlist[a].myov_struct, NULL) != 0)
					{
						t.Format(_T("Succeed re-set asynchronous ReadDirectoryChangesW(%s)"), watchlist[a].fullpath);
						m_EventLogSource.Report(EVENTLOG_INFORMATION_TYPE, t);
					}	
					else 
					{
						t.Format(_T("Failed re-set asynchronous ReadDirectoryChangesW(%s), will try again later..."), watchlist[a].fullpath);
						m_EventLogSource.Report(EVENTLOG_ERROR_TYPE, t);
					}
				}
			}
			ResetEvent(hOurHandlesArr[1]);
		}
		//signalled - changes detected on volume ??
		else if(dwRet >= (WAIT_OBJECT_0+3) && dwRet <= (WAIT_OBJECT_0+3+wlist_len))
		{
			CString t;
			BYTE mybuf[16384];
			DWORD len=0;
			//get data length and reset event
			if(GetOverlappedResult(watchlist[dwRet-3].hDir, &watchlist[dwRet-3].myov_struct, &len, FALSE))
			{
				memcpy(mybuf, watchlist[dwRet-3].asyncbuf, len);
				ResetEvent(watchlist[dwRet-3].myov_struct.hEvent);
				//re-set up our watcher
				DWORD buff_len1=0;
				if(ReadDirectoryChangesW(watchlist[dwRet-3].hDir, &watchlist[dwRet-3].asyncbuf, sizeof(watchlist[dwRet-3].asyncbuf), FALSE, FILE_NOTIFY_CHANGE_DIR_NAME, &buff_len1, &watchlist[dwRet-3].myov_struct, NULL) != 0)
				{
					t.Format(_T("Succeed re-set asynchronous ReadDirectoryChangesW(%s)"), watchlist[dwRet-3].fullpath);
					m_EventLogSource.Report(EVENTLOG_INFORMATION_TYPE, t);
				}
				else 
				{
					t.Format(_T("Failed re-set asynchronous ReadDirectoryChangesW(%s)"), watchlist[dwRet-3].fullpath);
					m_EventLogSource.Report(EVENTLOG_ERROR_TYPE, t);
				}
				//now we are ready to process the changes :)
				ProcessNotifyData(dwRet-3, &mybuf[0]);
			}
		}
	}
	
	for(a=0;a<wlist_len;a++)
	{
		CancelIo(watchlist[a].hDir);
		CloseHandle(watchlist[a].hDir);
	}
	for(a=0;a<3+wlist_len;a++) if (hOurHandlesArr[a]) CloseHandle(hOurHandlesArr[a]);

	ReportStatus(SERVICE_STOP_PENDING, 1, 100);
}

void CMyService::OnStop()
{
	//Signal the other thread to end via the boolean variable
	InterlockedExchange(&m_lWantStop, TRUE);
	
	SetEvent(hOurHandlesArr[0]);
}

DWORD CMyService::OnDeviceEvent(DWORD dwEventType, LPVOID lpEventData)
{
    switch (dwEventType)
    {
        case DBT_DEVICEREMOVECOMPLETE:
        {
			SetEvent(hOurHandlesArr[1]);
        }
        break;
        case DBT_DEVICEARRIVAL:
        {
			SetEvent(hOurHandlesArr[1]);
        }
        break;
    }
	return NO_ERROR;
}

void CMyService::ShowHelp()
{
	_tprintf(_T("Service that monitor paths for a changes and maintain server shares automatically\nUsage: AutoShServ [ -install | -uninstall | -remove | -start | -pause | -continue | -stop | -help | -? ]\n"));
}

bool CMyService::ProcessNotifyData(int wlist_id, BYTE *memory)
{
	CString msg;
	DWORD offset=0;
	PFILE_NOTIFY_INFORMATION fni = (FILE_NOTIFY_INFORMATION*)memory;

	do
	{
		TCHAR filename[MAX_PATH];
		offset=fni->NextEntryOffset;
		lstrcpynW(filename, fni->FileName, fni->FileNameLength/sizeof(WCHAR)+1);
		msg.Format(_T("Notify come for path %s, dir: %s, Action: %d\n"), watchlist[wlist_id].fullpath, filename, fni->Action);
		switch(fni->Action)
		{
		case FILE_ACTION_RENAMED_NEW_NAME:
		case FILE_ACTION_ADDED:
			//check if supplied dir exist under   if so - then first delete old share
			for(int a=0;a<wlist_len;a++)
			{
				//exclude CURRENT directory from analyze
				if(a!=wlist_id && CheckIfDirExist(watchlist[a].fullpath, filename))
				{
					//
					msg.AppendFormat(_T("this dir exist at %s, guess this is move between volumes?\n"), watchlist[a].fullpath);
					DeleteShare(a, watchlist[a].fullpath, filename, msg);
				}
			}
			MakeDirShared(wlist_id, watchlist[wlist_id].fullpath, filename, msg);
			break;
		case FILE_ACTION_RENAMED_OLD_NAME:
		case FILE_ACTION_REMOVED:
			//      50     ? 
			//       ,          :)
			DeleteShare(wlist_id, watchlist[wlist_id].fullpath, filename, msg);
			break;
		}
		fni = (PFILE_NOTIFY_INFORMATION)((LPBYTE)fni + fni->NextEntryOffset); 
		m_EventLogSource.Report(EVENTLOG_INFORMATION_TYPE, msg);
	}
	while(offset != 0L);

	return 0;
}

bool CMyService::CheckIfDirExist(TCHAR *path, TCHAR *dir)
{
	bool ret_val=true;
	HANDLE hDir = INVALID_HANDLE_VALUE;
	TCHAR fullpath[MAX_PATH];

	wsprintf(fullpath, _T("%s\\%s"), path, dir);
	hDir = CreateFile(fullpath, FILE_LIST_DIRECTORY, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS, NULL);
	if(hDir == INVALID_HANDLE_VALUE)
	{
		ret_val=false;
	}
	CloseHandle(hDir);

	return ret_val;
}

void CMyService::MakeDirShared(int wlist_id, TCHAR *pathprefix, TCHAR *dir, CString &messagesbuf)
{
    DWORD dwRes;
    PSID pEveryoneSID = NULL;
    PACL pACL = NULL;
    PSECURITY_DESCRIPTOR pSD = NULL;
    EXPLICIT_ACCESS ea[1];
    SID_IDENTIFIER_AUTHORITY SIDAuthWorld = SECURITY_WORLD_SID_AUTHORITY;

    if(!AllocateAndInitializeSid(&SIDAuthWorld, 1, SECURITY_WORLD_RID, 0, 0, 0, 0, 0, 0, 0, &pEveryoneSID))
    {
        m_EventLogSource.Report(EVENTLOG_INFORMATION_TYPE, _T("AllocateAndInitializeSid() error"));
        goto Cleanup;
    }

    ZeroMemory(&ea, 1 * sizeof(EXPLICIT_ACCESS));
    ea[0].grfAccessPermissions = GENERIC_ALL;
    ea[0].grfAccessMode = SET_ACCESS;
    ea[0].grfInheritance= NO_INHERITANCE;
    ea[0].Trustee.TrusteeForm = TRUSTEE_IS_SID;
    ea[0].Trustee.TrusteeType = TRUSTEE_IS_WELL_KNOWN_GROUP;
    ea[0].Trustee.ptstrName  = (LPTSTR) pEveryoneSID;

    dwRes = SetEntriesInAcl(1, ea, NULL, &pACL);
    if (ERROR_SUCCESS != dwRes) 
    {
        m_EventLogSource.Report(EVENTLOG_INFORMATION_TYPE, _T("SetEntriesInAcl() Error"));
        goto Cleanup;
    }

    pSD = (PSECURITY_DESCRIPTOR) LocalAlloc(LPTR, SECURITY_DESCRIPTOR_MIN_LENGTH); 
    if (NULL == pSD) 
    { 
        m_EventLogSource.Report(EVENTLOG_INFORMATION_TYPE, _T("LocalAlloc() Error"));
        goto Cleanup; 
    } 
 
    if (!InitializeSecurityDescriptor(pSD, SECURITY_DESCRIPTOR_REVISION)) 
    {  
        m_EventLogSource.Report(EVENTLOG_INFORMATION_TYPE, _T("InitializeSecurityDescriptor() Error"));
        goto Cleanup; 
    } 
 
    if (!SetSecurityDescriptorDacl(pSD, TRUE, pACL, FALSE))
    {  
        m_EventLogSource.Report(EVENTLOG_INFORMATION_TYPE, _T("SetSecurityDescriptorDacl() Error"));
        goto Cleanup; 
    } 

	SHARE_INFO_502 info; 
	TCHAR fullpath[MAX_PATH];
	TCHAR sharename[MAX_PATH];
	
	wsprintf(fullpath, _T("%s\\%s"), pathprefix, dir);
	wsprintf(sharename, _T("%s$"), dir);

	info.shi502_netname = sharename;
	info.shi502_type = STYPE_DISKTREE; 
	info.shi502_remark = (LPTSTR)L""; 
	info.shi502_permissions = ACCESS_ALL; 
	info.shi502_max_uses = -1; 
	info.shi502_current_uses = 0; 
	info.shi502_path = fullpath; 
	info.shi502_passwd = (LPTSTR)L""; 
	info.shi502_reserved = 0; 
	info.shi502_security_descriptor = pSD; 
	DWORD parm_err;
	Sleep(100);
	dwRes=NetShareAdd(watchlist[wlist_id].share, 502, (LPBYTE) &info, &parm_err);
	if(dwRes==0) 
	{
		messagesbuf.AppendFormat(_T("%s share success created\n"), sharename);
		//wsprintf(msgbuf, _T("%s share success created"), sharename);
		//m_EventLogSource.Report(EVENTLOG_INFORMATION_TYPE, msgbuf);
	}
	else 
	{
		LPVOID lpMsgBuf;
		FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, NULL, dwRes, 0, (LPTSTR) &lpMsgBuf, 0, NULL);
		//wsprintf(msgbuf, _T("%s share can't be created! NetShareAdd() Error: %s"), sharename, lpMsgBuf);
		messagesbuf.AppendFormat(_T("%s share can't be created! NetShareAdd() Error: %s\n"), sharename, lpMsgBuf);
		LocalFree(lpMsgBuf);
		//m_EventLogSource.Report(EVENTLOG_WARNING_TYPE, msgbuf);
	}

	SetShareCache(wlist_id, sharename, 0, messagesbuf);
	ModifyDirACL(fullpath, dir, messagesbuf);


Cleanup:
    if (pEveryoneSID) 
        FreeSid(pEveryoneSID);
    if (pACL) 
        LocalFree(pACL);
    if (pSD) 
        LocalFree(pSD);

    return;

}

void CMyService::DeleteShare(int wlist_id, TCHAR *pathprefix, TCHAR *dir, CString &messagesbuf)
{
	NET_API_STATUS dwRes;
	PSHARE_INFO_502 BufPtr;
	TCHAR sharename[MAX_PATH], path2[MAX_PATH] = {0};
	
	Sleep(100);

	//get full disk path to share
	wsprintf(sharename, _T("%s$"), dir);
	dwRes=NetShareGetInfo(watchlist[wlist_id].share, sharename, 502, (LPBYTE *)&BufPtr);
	if(dwRes == ERROR_SUCCESS)
	{
		wcscpy(path2, BufPtr->shi502_path);
		NetApiBufferFree(BufPtr);
	}

	//see if requested share deletion path equals to real share path
	wsprintf(sharename, _T("%s\\%s"), pathprefix, dir);
	if(wcsicmp(path2, sharename) != 0)
	{
		messagesbuf.AppendFormat(_T("Path %s for share %s$ is not equal to caller spefied %s , no changes will be maded\n"), path2, dir, sharename);
		return;
	}

	//del share
	wsprintf(sharename, _T("%s$"), dir);
	dwRes=NetShareDel(watchlist[wlist_id].share, sharename, 0);
	if(dwRes==ERROR_SUCCESS)
	{
		messagesbuf.AppendFormat(_T("%s share removed success\n"), sharename);
	}
	else
	{
		LPVOID lpMsgBuf;
		FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, NULL, dwRes, 0, (LPTSTR) &lpMsgBuf, 0, NULL);
		messagesbuf.AppendFormat(_T("%s share can't be deleted! NetShareDel() Error: %s\n"), sharename, lpMsgBuf);
		LocalFree(lpMsgBuf);
	}

	return;
}

void CMyService::SetShareCache(int wlist_id, TCHAR *dir, int cache, CString &messagesbuf)
{
	SHARE_INFO_1005 p = {0};
	NET_API_STATUS res;
	DWORD parm_err = 0;

	switch(cache)
	{
		case 3: p.shi1005_flags=CSC_CACHE_MANUAL_REINT; break;
		case 2: p.shi1005_flags=CSC_CACHE_AUTO_REINT; break;
		case 1: p.shi1005_flags=CSC_CACHE_VDO; break;
		case 0:
		default: p.shi1005_flags=CSC_CACHE_NONE; break;
	}
	res=NetShareSetInfo(watchlist[wlist_id].share, dir, 1005, (LPBYTE)&p, &parm_err);
	if(res==0)
	{
		messagesbuf.AppendFormat(_T("Caching policy for %s share set success\n"), dir);
	}
	else
	{
		messagesbuf.AppendFormat(_T("%s cache policy can't set! NetShareSetInfo() Error: %u\n"), dir, res);
	}

	return;
}

void CMyService::ModifyDirACL(TCHAR *pathprefix, TCHAR *dir, CString &messagesbuf)
{
	EXPLICIT_ACCESS explicitaccess;
	PACL NewAcl = NULL, pOldDAcl = NULL;
	PSECURITY_DESCRIPTOR ppSecurityDescriptor;
	DWORD dwError;
	TCHAR msgbuf[MAX_PATH];
	
	wsprintf(msgbuf, _T("%s"), dir);

	GetNamedSecurityInfo(pathprefix, SE_FILE_OBJECT, DACL_SECURITY_INFORMATION, NULL, NULL, &pOldDAcl, NULL, &ppSecurityDescriptor);
	BuildExplicitAccessWithName(&explicitaccess, msgbuf, GENERIC_READ|GENERIC_WRITE|GENERIC_EXECUTE|DELETE, GRANT_ACCESS, SUB_CONTAINERS_AND_OBJECTS_INHERIT);
	dwError = SetEntriesInAcl(1, &explicitaccess, pOldDAcl, &NewAcl);
	if(dwError != ERROR_SUCCESS)
	{
		LPVOID lpMsgBuf;
		FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, NULL, GetLastError(), 0, (LPTSTR) &lpMsgBuf, 0, NULL);
		messagesbuf.AppendFormat(_T("SetEntriesInAcl() error: %s\n"), lpMsgBuf);
		LocalFree(lpMsgBuf);
		if( NewAcl != NULL ) AccFree( NewAcl ); 
		return;
	}

	dwError = SetNamedSecurityInfo(pathprefix, SE_FILE_OBJECT, DACL_SECURITY_INFORMATION, NULL, NULL, NewAcl, NULL );
	if(dwError == ERROR_SUCCESS) 
		messagesbuf.AppendFormat(_T("Success added MODIFY permission for user %s\n"), msgbuf);
	else
	{
		LPVOID lpMsgBuf;
		FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, NULL, GetLastError(), 0, (LPTSTR) &lpMsgBuf, 0, NULL);
		messagesbuf.AppendFormat(_T("%s MODIFY permission addition fail! SetNamedSecurityInfo() Error: %s\n"), pathprefix, lpMsgBuf);
		LocalFree(lpMsgBuf);
	}

	if(NewAcl != NULL) AccFree(NewAcl);

	return;
}

bool CMyService::LoadConfiguration(void)
{
	TiXmlNode *RootNode;
	TCHAR u_execpath[MAX_PATH];
	char ExecPath[MAX_PATH];
	int len;
	CString t;

	GetModuleFileName(NULL, u_execpath, MAX_PATH);
	wcstombs(ExecPath, u_execpath, MAX_PATH);
	char *ptr=strrchr(ExecPath, '\\');
	if(ptr) 
	{
		len=ptr - &ExecPath[0] +1;
		ExecPath[len]=0x00;
	}

	strcat(ExecPath, "\\autoshares.xml");

	TiXmlDocument mdoc(ExecPath);
	if(!mdoc.LoadFile(TIXML_ENCODING_LEGACY)) 
	{
		t.Format(_T("Error loading autoshares.xml configuration. XML details:"), mdoc.ErrorDesc());
		m_EventLogSource.Report(EVENTLOG_ERROR_TYPE, t);
		return false;
	}

	RootNode = mdoc.FirstChild("config");
	if(!RootNode) 
	{
		m_EventLogSource.Report(EVENTLOG_ERROR_TYPE, _T("Config file opened but cannot find ROOT 'config' in it\n"));
	}

	TiXmlNode *child=0;
	while(child = RootNode->IterateChildren(child))
	{
		TiXmlElement *wpos=child->ToElement();
		//
		if(wlist_len > 4) break;
		if(strcmp(child->Value(), "watch") == 0)
		{
			if(wpos->Attribute("diskpath") && wpos->Attribute("sharepath"))
			{
				mbstowcs(watchlist[wlist_len].fullpath, wpos->Attribute("diskpath"), MAX_PATH);
				mbstowcs(watchlist[wlist_len].share, wpos->Attribute("sharepath"), 30);
				m_EventLogSource.Report(EVENTLOG_INFORMATION_TYPE, _T("Adding watching rule"));
				wlist_len++;
			}
		}
	}


	return true;
}
