#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "ntserv.h"
#include "ntservServiceControlManager.h"
#include "tinyxml.h"

struct wlist {
	TCHAR fullpath[MAX_PATH]; //holds filesystem path
	TCHAR share[30];  //holds server share name
	OVERLAPPED myov_struct;  //our overlapped struct working with readdirchangenotify
	HANDLE hDir; //handle to our filesystem path
	BYTE asyncbuf[16384]; //asynchronious buffer receiving data from readdirchangenotify
};

class CMyService : public CNTService
{
public:
	CMyService();
	virtual void WINAPI ServiceMain(DWORD dwArgc, LPTSTR* lpszArgv);
	virtual void OnStop();
	virtual void ShowHelp();
	virtual DWORD OnDeviceEvent(DWORD dwEventType, LPVOID lpEventData);
	//virtual void _ServiceMain(DWORD dwArgc, LPTSTR* lpszArgv);

protected:
	volatile long m_lWantStop;
	struct wlist watchlist[5];
	int wlist_len;
	HANDLE hOurHandlesArr[3+5];
	
	bool CheckIfDirExist(TCHAR *path, TCHAR *dir);
	bool ProcessNotifyData(int wlist_id, BYTE *memory);
	void MakeDirShared(int wlist_id, TCHAR *pathprefix, TCHAR *dir, CString &messagesbuf);
	void DeleteShare(int wlist_id, TCHAR *pathprefix, TCHAR *dir, CString &messagesbuf);
	void SetShareCache(int wlist_id, TCHAR *dir, int cache, CString &messagesbuf);
	void ModifyDirACL(TCHAR *pathprefix, TCHAR *dir, CString &messagesbuf);
	bool LoadConfiguration(void);
};

